package Ftp;
use strict;
######################################################################
# Ftp.pm : FTP]W[
######################################################################

use Net::FTP;			# FTPڑ
use Password;			# ÍE
use ServerList;			# T[o[Xg


sub new($){
	my $this = shift;
	bless {
		Ftp => undef,			# FTPW[ێ
		ServerList => new ServerList(shift),	# T[o[Xg
		IsDebug => 0,			# fobO[hɂ邩
		ServerName => '',		# ݐڑĂT[o[
		RemotePath => '/',		# ݐڑĂ郊[gpX
		IsAsciiMode => 1,		# eLXg[h(0:oCi 1:eLXg)
	} => $this;
}

# T[o[ɐڑ
sub Open($){
	my $this = shift;
	my $server_name = shift;		# T[o[

	return if ($server_name eq $this->{ServerName});	# łɐڑς݂

	my $server = $this->{ServerList}->get($server_name);
	Close($this);				# ڑ
	($this->{Ftp} = new Net::FTP($server->{Host}, Debug => $this->{IsDebug}))
		? print "$server_name : $server->{Host}ɐڑ܂\n"
		: die "$server_name : $server->{Host}ɐڑł܂ł";

	unless ($server->{Pass}){
		if ($server->{CryptPass}){
			$server->{Pass} = new Password->DeCrypt($server->{CryptPass});
		} else{
			# PassȂ͂
			print "PassWord :";
			$server->{Pass} = new Password->ReadPassword();
		}
	}
	$this->{Ftp}->login($server->{Name},$server->{Pass})
		? print "OC܂\n"
		: die "OCɎs܂";

	$this->{ServerName} = $server_name;
	$this->{RemotePath} = '/';
}

# T[o[Ƃ̐ڑ
sub Close{
	my $this = shift;
	if ($this->{Ftp}){
		$this->{Ftp}->quit();
		print "$this->{ServerName}ؒf܂\n";
		undef ($this->{Ftp});
	}
}

# fBNgړ
sub Cwd($){
	# [gfBNg
	my $this = shift;
	my $remote_dir = shift;
	if ($this->{RemotePath} ne $remote_dir){
		if ($this->{Ftp}->cwd($remote_dir)){
			print "$remote_dirɈړ܂\n";
		}else{
			# fBNg쐬邩H
			print "$remote_dirւ̈ړɎs܂\n",
			      "fBNg쐬܂H(y/N) :";
			my $input = <STDIN>;
			($input =~ /^y/i) or die "fBNgړs";
			$this->MkDir($remote_dir);
		}
		$this->{RemotePath} = $remote_dir;
	}
}

# fBNg쐬
sub MkDir($){
	my $this = shift;
	my $dir = shift;
	return if $this->{Ftp}->cwd($dir);
	
	my ($path1,$path2) = $dir =~ m|(.*)/([^/]*)$|;
	$this->MkDir($path1 ||= '/');

	return unless $path2;
	$this->{Ftp}->mkdir($path2) or die "$path2쐬s";
	print "$path2쐬܂\n";
	$this->{Ftp}->cwd($path2);
	print "$path2Ɉړ܂\n";
}

# ]
sub Put($){
	my $this = shift;
	my $file = shift;
	# t@C[h
	if (-T $file){	# eLXgf[^
		unless ($this->{IsAsciiMode}){
			$this->{IsAsciiMode} = 1;
			$this->{Ftp}->ascii() and print "Ascii[hɈڍs܂\n";
		}
	} else{		# oCif[^
		if ($this->{IsAsciiMode}){
			$this->{IsAsciiMode} = 0;
			$this->{Ftp}->binary() and print "Binary[hɈڍs܂\n";
		}
	}
	
	# [ppAbv[hႤ[
	$this->{Ftp}->put($file)
		? print "$fileAbv[h܂\n"
		: die "$filẽAbv[hɎs܂";
}

1;
